//{$WARNINGS OFF}
//=============================================================================
//  wEBhEKẃCIAccessiblẽIuWFNgKwIɗ
//  TreeViewNodeɒǉĂ
//
//-----------------------------------------------------------------------------
//
//  ygpz
//
//  TCg̃AvP[VށCR|[lgCR[hނ́C]ځCρCzz
//  (IWiCϔ)Ȃǂ͑SĎRłDppRłDACgp̋L
//  ڋ`܂DIWî̂pƂ邱Ƃ͋֎~܂D
//  ܂Czz̍ہCȂ闝R낤Ƃɑ㉿߂邱Ƃ֎~܂D
//  ȂC{TCg̃vOR[hgpƂɂĐCȂ
//  QCɊւĂ҂͈؊֗^Ȃ̂Ƃ܂DD
//
//-----------------------------------------------------------------------------
//
//  yz
//
//  2012N0528 `
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows XP(SP3)    + Delphi XE Pro
//  Windows 7 U64(SP1) + Delphi XE Pro
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit plEnumAccInfos;

interface

uses
  Windows, SysUtils, Forms, ActiveX, OleAcc, Variants, ComCtrls;

type
  //IuWFNg̏p̃R[h^
  //em[hDataՃpeBɑ
  TplAccInfoRec = record
    ChildID : Integer;
    pAcc    : IAccessible;
  end;
  PplAccInfoRec = ^TplAccInfoRec;

  //J֐
  procedure EnumAccObjectTree(hWindow: HWND; Tree: TTreeView; dwID: Cardinal);
  procedure EnumAccTreeItems(Acc: IAccessible; ATree: TTreeView; ANode: TTreeNode);
  function AddChildNode(AccChild: IAccessible; ChildID: Integer; ATree: TTreeView;
    ANode: TTreeNode): TTreeNode;
  procedure AccObjectInfo(LV : TListView; Node: TTreeNode);
  function GetAccObjectValue(Acc: IAccessible; ChildID: Integer): String;
  function GetAccObjectRect(Acc: IAccessible; ChildID: Integer): TRect;
  function IsAccObjectVisible(Acc: IAccessible; ChildID: Integer): Boolean;

  //ȉ̊֐́CDelphi XEɂȂ̂Œ`
  function WindowFromAccessibleObject(paccContainer: IAccessible; var phwnd: HWND):
    HRESULT;stdcall; external 'oleacc.dll';
  function AccessibleChildren(paccContainer: IAccessible; iChildStart,
    cChildren: Longint; rgvarChildren: PVariantArg;
    pcObtained: PLongint): HRESULT; stdcall; external 'oleacc.dll';
  function AccessibleObjectFromPoint(ptScreen: TPoint; out ppacc: IAccessible;
    out pvarChild): HRESULT; stdcall; external 'oleacc.dll';
  function GetRoleTextW(dwRole: DWORD; lpszRole: PWideChar;
    cchRoleMax: UINT): UINT; stdcall; external 'oleacc.dll';
  function GetStateTextW(dwStateBit: DWORD; lpszStateBit: PWideChar;
    cchStateBitMax: UINT): UINT; stdcall; external 'oleacc.dll';

implementation

var
  //Ԃ̃IuWFNĝ݂ΏۂƂ
  OnlyVisible : Boolean = True;

//=============================================================================
//  nhlhWindow̃EBhẼIuWFNgċAIɌė
//  TreeViewNodeɒǉĂ
//
//  hWindow     : EBhẼnh
//  Tree        : TreeView
//  dwID        : IuWFNg̃JeS[
//=============================================================================
procedure EnumAccObjectTree(hWindow: HWND; Tree: TTreeView; dwID: Cardinal);
var
  oAccessible : IAccessible;
  RootNode    : TTreeNode;
begin
  Tree.Items.Clear;

  //EBhEnhIAccessibleIuWFNg擾
  if AccessibleObjectFromWindow(hWindow,
                                dwID,
                                IID_IAccessible,
                                Pointer(oAccessible)) <> S_OK then exit;

  //[gm[h
  RootNode := AddChildNode(oAccessible, CHILDID_SELF, Tree, nil);

  Tree.Items.BeginUpdate;
  //񋓎s
  EnumAccTreeItems(oAccessible, Tree, RootNode);
  Tree.Items.EndUpdate;
  Tree.TopItem.Expand(False);
end;

//=============================================================================
//  AccKw̎qIuWFNg
//  TreeViewɃc[\
//=============================================================================
procedure EnumAccTreeItems(Acc: IAccessible; ATree: TTreeView; ANode: TTreeNode);
var
  Children   : array of TVariantArg;
  ChildCount : Integer;
  Obtained   : Integer;
  AccChDisp  : IDispatch;
  AccChild   : IAccessible;
  ChildID    : Integer;
  i          : Integer;
  j          : Integer;
  AddNode    : TTreeNode;
  HasChild   : Integer;
begin
  if Acc = nil then exit;

  //qIuWFNg̐𒲂ׂ
  if (Acc.get_accChildCount(ChildCount) = S_OK) then begin
    Application.ProcessMessages;
    SetLength(Children, ChildCount);

    //oAgz̏
    for i := 0 to ChildCount - 1 do begin
      VariantInit(OleVariant(Children[i]));
    end;

    //ANZX\ȎqIuWFNg̐𒲍
    if AccessibleChildren(Acc, 0, ChildCount, @Children[0], @Obtained) = S_OK
        then begin
      for j := 0 to Obtained - 1 do begin
        HasChild := -1;
        ChildID  := CHILDID_SELF;

        //qIuWFNg
        if Children[j].vt = VT_DISPATCH then begin
          AccChDisp := IDispatch(Children[j].pdispVal);
          if Assigned(AccChDisp) then begin
            AccChDisp.QueryInterface(IID_IAccessible, AccChild);
            ChildID  := CHILDID_SELF;
            HasChild := 1;
          end;
        end else begin
          if Children[j].vt = VT_I4 then begin
            //qIuWFNg͂Ȃ
            if Acc.get_accChild(OleVariant(Children[j]), AccChDisp) = S_FALSE
                then begin
              AccChild := Acc;
              ChildID  := Children[j].lVal;
              HasChild := 0;
            end else begin
               //qIuWFNg
              if Assigned(AccChDisp) then begin
                AccChDisp.QueryInterface(IID_IAccessible, AccChild);
                ChildID  := CHILDID_SELF;
                HasChild := 1;
              end;
            end;
          end;
        end;

        //1ɂ܂Ƃ߂邽߂HasChildtOƂĎgp
        if HasChild >= 0 then begin
          AddNode := AddChildNode(AccChild, ChildID, ATree, ANode);
          if (AddNode <> nil) and (HasChild = 1) then begin
            EnumAccTreeItems(AccChild, ATree, AddNode);
          end;
        end;
      end;
    end;
    //oAgžn
    for i := 0 to Obtained - 1 do begin
      VariantClear(OleVariant(Children[i]));
    end;
  end;
end;

//=============================================================================
//  ȉ̏s֐
//
//  TreeView̃m[hɕ\eLXg쐬
//  TreeViewɃm[hǉ
//  m[hDatavpeBɃIuWFNg̏CR[h^ő
//
//  ߂ĺCǉm[h̃CX^X
//  ̃IuWFNg̓m[hɒǉȂŁC߂lnilԂ
//=============================================================================
function AddChildNode(AccChild: IAccessible; ChildID: Integer; ATree: TTreeView;
  ANode: TTreeNode): TTreeNode;
var
  AName    : WideString;
  varRole  : OleVariant;
  Len      : Cardinal;
  TmpStr   : WideString;
  varID    : OleVariant;
  StrText  : WideString;
  pAccInfo : PplAccInfoRec;
begin
  Result  := nil;
  StrText := '';

  //Ԃ̃IuWFNĝ݂̏ꍇC̃IuWFNg͒ǉȂ
  if OnlyVisible then begin
    if not IsAccObjectVisible(AccChild, ChildID) then exit;
  end;

  //Role(IuWFNg̋@\C)vpeB𕶎ƂĎ擾
  TVariantArg(varID).vt   := VT_I4;
  TVariantArg(varID).lVal := ChildID;
  if AccChild.get_accRole(varID, varRole) = S_OK then begin
    if TVariantArg(varRole).vt = VT_I4 then begin
      Len := GetRoleTextW(TVariantArg(varRole).lVal, nil, 0);
      SetLength(TmpStr, Len);
      GetRoleTextW(TVariantArg(varRole).lVal, PWideChar(TmpStr), Len + 1);
      StrText := '[' + TmpStr + ']';
    end else begin
      StrText := '[' + String(varRole) + ']';
    end;
  end else begin
    StrText := '[]';
  end;

  //NamevpeB擾Ēǉ
  //RolevpeB̌̕ɒǉ
  if AccChild.get_accName(varID, AName) <> S_OK then AName := '';
  StrText := StrText + ' "' + AName + '"';

  //IuWFNg̕ǉ
  //C̃IuWFNgc[\eXgl邩
  //Ȃ̂Œǉ
  if not OnlyVisible then begin
    if IsAccObjectVisible(AccChild, ChildID) then begin
      StrText := StrText + ' ' + 'Visible';
    end else begin
      StrText := StrText + ' ' + 'InVisible';
    end;
  end;

  Result := ATree.Items.AddChild(ANode, StrText);

  //NodeDatavpeBɃIuWFNg̏
  if Result <> nil then begin
    New(pAccInfo);
    pAccInfo.ChildID := ChildID;
    pAccInfo.pAcc    := AccChild;
    Result.Data      := pAccInfo;
  end;
end;

//=============================================================================
//  IuWFNg̃vpeB̒l擾āCListViewɒǉĂ
//  get_accFocus֐get_accSelection֐ɂl͏ȗ
//
//  ListViewViewStylevsReportŁCJ2Ɖ肵Ă鎞̃R[h
//=============================================================================
procedure AccObjectInfo(LV : TListView; Node: TTreeNode);

  //---------------------------------------------------------------------------
  //  EBhẼNX擾֐
  //---------------------------------------------------------------------------
  function GetClassNameStr(hWindow: HWND): String;
  var
    Buffer : array[0..MAX_PATH-1] of Char;
    Len    : Integer;
  begin
    System.FillChar(Buffer, SizeOf(Buffer), #0);
    Len := Windows.GetClassName(hWindow, Buffer, Length(Buffer));
    if Len > 0 then Result := Buffer else Result := '';
  end;

  //---------------------------------------------------------------------------
  //  ListViewItemǉ郁\bh
  //---------------------------------------------------------------------------
  procedure ListViewItemAdd(LV: TListView; ACaption, SubItem: String);
  var
    LVItem : TListItem;
  begin
    LVItem               := LV.Items.Add;
    LVItem.Caption       := ACaption;
    LVItem.SubItems.Text := SubItem;
  end;
  //---------------------------------------------------------------------------

var
  pAccInfo : PplAccInfoRec;
  Acc      : IAccessible;
  ChildID  : Integer;
  hWindow  : HWND;
  StrText  : WideString;
  ATop     : Integer;
  ALeft    : Integer;
  AWidth   : Integer;
  AHeight  : Integer;
  varChild : OleVariant;
  varState : OleVariant;
  varRole  : OleVariant;
  TmpInt   : Integer;
  Len      : Cardinal;
  i        : Integer;
  StateID  : Integer;
  TmpStr   : String;
begin
  if Node.Data = nil then exit;

  LV.Items.Clear;
  //NodeDatavpeBIuWFNg̃f[^o
  pAccInfo := Node.Data;
  Acc      := pAccInfo.pAcc;
  ChildID  := pAccInfo.ChildID;

  LV.Items.BeginUpdate;

  StrText := '';
  hWindow := 0;
  if WindowFromAccessibleObject(Acc, hWindow) = S_OK then begin
    ListViewItemAdd (LV, 'Class Name', GetClassNameStr(hWindow));
  end;

  TVariantArg(varChild).vt   := VT_I4;
  TVariantArg(varChild).lVal := ChildID;

  if Acc.Get_accName(varChild, StrText) = S_OK then begin
    ListViewItemAdd (LV, 'Name', StrText);
  end else begin
    ListViewItemAdd (LV, 'Name', '-');
  end;

  StrText := '-';
  if Acc.get_accRole(varChild, varRole) = S_OK then begin
    if TVariantArg(varRole).vt = VT_I4 then begin
      Len := GetRoleTextW(TVariantArg(varRole).lVal, nil, 0);
      SetLength(StrText, Len);
      GetRoleTextW(TVariantArg(varRole).lVal, PWideChar(StrText), Len + 1);
    end;
  end;
  ListViewItemAdd (LV, 'Role', StrText);

  if Acc.accLocation(ALeft, ATop, AWidth, AHeight, varChild) = S_OK then begin
    if AWidth * AHeight <> 0 then begin
      StrText := '( ' + IntToStr(ALeft) + ', ' +
                        IntToStr(ATop)  + ', ' +
                        IntToStr(ALeft  + AWidth)  + ', ' +
                        IntToStr(ATop   + AHeight) + ' )';
      ListViewItemAdd (LV, 'Location', StrText);
    end else begin
      ListViewItemAdd (LV, 'Location', '-');
    end;
  end else begin
    ListViewItemAdd (LV, 'Location', '-');
  end;

  //Get_accChildCount֐Ŏ擾Ɣ̃IuWFNg܂܂̂
  //łTreeView̎qm[h̐\
  ListViewItemAdd (LV, 'ChildCount', IntToStr(Node.Count));

  if Acc.Get_accDefaultAction(varChild, StrText) = S_OK then begin
    ListViewItemAdd (LV, 'DefaultAction', StrText);
  end else begin
    ListViewItemAdd (LV, 'DefaultAction', '-');
  end;

  if Acc.Get_accDescription(varChild, StrText) = S_OK then begin
    ListViewItemAdd (LV, 'Description', StrText);
  end else begin
    ListViewItemAdd (LV, 'Description', '-');
  end;

  if Acc.Get_accHelp(varChild, StrText) = S_OK then begin
    ListViewItemAdd (LV, 'Help', StrText);
  end else begin
    ListViewItemAdd (LV, 'Help', '-');
  end;

  if Acc.Get_accHelpTopic(StrText, varChild, TmpInt) = S_OK then begin
    ListViewItemAdd (LV, 'HelpTopic', StrText + ' ( ' + IntToStr(TmpInt) + ' )');
  end else begin
    ListViewItemAdd (LV, 'HelpTopic', '-');
  end;

  if Acc.Get_accKeyboardShortcut(varChild, StrText) = S_OK then begin
    ListViewItemAdd (LV, 'KeyboardShortcut', StrText);
  end else begin
    ListViewItemAdd (LV, 'KeyboardShortcut', '-');
  end;

  //StatevpeB̒l擾āCGetStateTextW֐Őɕϊ
  //Statȅ͕ꍇ
  //StatevpeB̒l2̔{őĂƂ𗘗pă[v
  StrText := '';
  StateID := 1;
  if Acc.Get_accState(varChild, varState) = S_OK then begin
    if TVariantArg(varState).vt = VT_I4 then begin
      TmpInt := TVariantArg(varState).lVal;
      for i := 1 to 29 do begin
        if (TmpInt and StateID) <> 0 then begin
          Len := GetStateTextW(StateID, nil, 0);
          SetLength(TmpStr, Len);
          GetStateTextW(StateID, PWideChar(TmpStr), Len);
          StrText := StrText + Trim(TmpStr) + 'B' ;
        end;
        StateID := StateID * 2;
      end;
    end;
  end;
  ListViewItemAdd (LV, 'State', StrText);

  //ŏ1ŝ݂̕\ƂȂ(o͐悪TListViewȂ̂ŕs\͕s)
  if Acc.Get_accValue(varChild, StrText) = S_OK then begin
    ListViewItemAdd (LV, 'Value', StrText);
  end else begin
    ListViewItemAdd (LV, 'Value', '-');
  end;

  ListViewItemAdd (LV, 'ChildID', IntToStr(ChildID));

  LV.Items.EndUpdate;
end;

//=============================================================================
//  ValuevpeB擾p̊֐
//=============================================================================
function GetAccObjectValue(Acc: IAccessible; ChildID: Integer): String;
var
  varChild : OleVariant;
  StrText  : WideString;
begin
  Result := '';

  TVariantArg(varChild).vt   := VT_I4;
  TVariantArg(varChild).lVal := ChildID;

  if Acc.Get_accValue(varChild, StrText) = S_OK then begin
    Result := StrText;
  end;
end;

//=============================================================================
//  IuWFNg̈ʒuƃTCYCTRectR[h^Ɏ擾֐
//=============================================================================
function GetAccObjectRect(Acc: IAccessible; ChildID: Integer): TRect;
var
  ATop     : Integer;
  ALeft    : Integer;
  AWidth   : Integer;
  AHeight  : Integer;
  varChild : OleVariant;
begin
  TVariantArg(varChild).vt   := VT_I4;
  TVariantArg(varChild).lVal := ChildID;

  if Acc.accLocation(ALeft, ATop, AWidth, AHeight, varChild) = S_OK then begin
    Result.Top    := ATop;
    Result.Left   := ALeft;
    Result.Right  := ALeft + AWidth;
    Result.Bottom := ATop  + AHeight;
  end;
end;

//=============================================================================
//  IuWFNg̉Ԃ擾֐
//  ԂȂTrueCłFlaseԂ
//  MSDNɂ΁C̒l͕Kmł͂Ȃ悤
//  eIuWFNg̏ԂlׂƂ
//=============================================================================
function IsAccObjectVisible(Acc: IAccessible; ChildID: Integer): Boolean;
var
  varChild : OleVariant;
  varState : OleVariant;
  VState   : Cardinal;
begin
  Result := True;

  TVariantArg(varChild).vt   := VT_I4;
  TVariantArg(varChild).lVal := ChildID;

  if Acc.Get_accState(varChild, varState) = S_OK then begin
    if TVariantArg(varState).vt = VT_I4 then begin
      VState :=  TVariantArg(varState).lVal;
      Result := (VState and STATE_SYSTEM_INVISIBLE) = 0;
    end;
  end;
end;

end.
